# generated by datamodel-codegen:
#   filename:  oscal_assessment-plan_schema.json
#   timestamp: 2023-03-20T21:15:53+00:00

from __future__ import annotations

from dataclasses import dataclass
from enum import Enum
from typing import List, Optional

LocationURL = str


LocationReference = str


class PartyType(Enum):
    person = 'person'
    organization = 'organization'


@dataclass
class PartyExternalIdentifier:
    scheme: str
    id: str


OrganizationalAffiliation = str


PartyReference = str


RoleIdentifierReference = str


@dataclass
class Base64:
    filename: Optional[str] = None
    media_type: Optional[str] = None
    value: str


@dataclass
class Link:
    href: str
    rel: Optional[str] = None
    media_type: Optional[str] = None
    text: Optional[str] = None


@dataclass
class Hash:
    algorithm: str
    value: str


Remarks = str


PublicationTimestamp = str


LastModifiedTimestamp = str


DocumentVersion = str


OSCALVersion = str


EmailAddress = str


@dataclass
class TelephoneNumber:
    type: Optional[str] = None
    number: str


AddressLine = str


@dataclass
class DocumentIdentifier:
    scheme: Optional[str] = None
    identifier: str


@dataclass
class ImportSystemSecurityPlan:
    href: str
    remarks: Optional[Remarks] = None


@dataclass
class OnDateCondition:
    date: str


@dataclass
class OnDateRangeCondition:
    start: str
    end: str


class TimeUnit(Enum):
    seconds = 'seconds'
    minutes = 'minutes'
    hours = 'hours'
    days = 'days'
    months = 'months'
    years = 'years'


@dataclass
class FrequencyCondition:
    period: int
    unit: TimeUnit


@dataclass
class EventTiming:
    on_date: Optional[OnDateCondition] = None
    within_date_range: Optional[OnDateRangeCondition] = None
    at_frequency: Optional[FrequencyCondition] = None


@dataclass
class TaskDependency:
    task_uuid: str
    remarks: Optional[Remarks] = None


IncludeSpecificStatements = str


@dataclass
class SelectControl:
    control_id: str
    statement_ids: Optional[List[IncludeSpecificStatements]] = None


@dataclass
class SelectObjective:
    objective_id: str


@dataclass
class AssessmentSubjectSource:
    task_uuid: str


class FindingTargetType(Enum):
    statement_id = 'statement-id'
    objective_id = 'objective-id'


class ObjectiveStatusState(Enum):
    satisfied = 'satisfied'
    not_satisfied = 'not-satisfied'


@dataclass
class ObjectiveStatus1:
    state: ObjectiveStatusState
    reason: Optional[str] = None
    remarks: Optional[Remarks] = None


ObservationMethod = str


ObservationType = str


class ActorType(Enum):
    tool = 'tool'
    assessment_platform = 'assessment-platform'
    party = 'party'


@dataclass
class ThreatID:
    system: str
    href: Optional[str] = None
    id: str


@dataclass
class RelatedObservation:
    observation_uuid: str


@dataclass
class LoggedBy:
    party_uuid: str
    role_id: Optional[str] = None


RiskStatus = str


@dataclass
class ConstraintTest:
    expression: str
    remarks: Optional[Remarks] = None


@dataclass
class Constraint:
    description: Optional[str] = None
    tests: Optional[List[ConstraintTest]] = None


@dataclass
class Guideline:
    prose: str


ParameterValue = str


class ParameterCardinality(Enum):
    one = 'one'
    one_or_more = 'one-or-more'


@dataclass
class Selection:
    how_many: Optional[ParameterCardinality] = None
    choice: Optional[List[str]] = None


@dataclass
class IncludeAll:
    pass


class State(Enum):
    under_development = 'under-development'
    operational = 'operational'
    disposition = 'disposition'
    other = 'other'


@dataclass
class Status:
    state: State
    remarks: Optional[Remarks] = None


class Transport(Enum):
    TCP = 'TCP'
    UDP = 'UDP'


@dataclass
class PortRange:
    start: Optional[int] = None
    end: Optional[int] = None
    transport: Optional[Transport] = None


@dataclass
class ImplementationStatus:
    state: str
    remarks: Optional[Remarks] = None


FunctionsPerformed = str


@dataclass
class SetParameterValue:
    param_id: str
    values: List[ParameterValue]
    remarks: Optional[Remarks] = None


@dataclass
class SystemIdentification:
    identifier_type: Optional[str] = None
    id: str


@dataclass
class ResourceLink:
    href: str
    media_type: Optional[str] = None
    hashes: Optional[List[Hash]] = None


@dataclass
class Property:
    name: str
    uuid: Optional[str] = None
    ns: Optional[str] = None
    value: str
    class_: Optional[str] = None
    remarks: Optional[Remarks] = None


@dataclass
class ResponsibleParty:
    role_id: str
    party_uuids: List[PartyReference]
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    remarks: Optional[Remarks] = None


@dataclass
class ResponsibleRole:
    role_id: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    party_uuids: Optional[List[PartyReference]] = None
    remarks: Optional[Remarks] = None


@dataclass
class Address:
    type: Optional[str] = None
    addr_lines: Optional[List[AddressLine]] = None
    city: Optional[str] = None
    state: Optional[str] = None
    postal_code: Optional[str] = None
    country: Optional[str] = None


@dataclass
class AssessedControls:
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    include_all: Optional[IncludeAll] = None
    include_controls: Optional[List[SelectControl]] = None
    exclude_controls: Optional[List[SelectControl]] = None
    remarks: Optional[Remarks] = None


@dataclass
class ReferencedControlObjectives:
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    include_all: Optional[IncludeAll] = None
    include_objectives: Optional[List[SelectObjective]] = None
    exclude_objectives: Optional[List[SelectObjective]] = None
    remarks: Optional[Remarks] = None


@dataclass
class ReviewedControlsAndControlObjectives:
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    control_selections: List[AssessedControls]
    control_objective_selections: Optional[List[ReferencedControlObjectives]] = None
    remarks: Optional[Remarks] = None


@dataclass
class AssessmentSubjectPlaceholder:
    uuid: str
    description: Optional[str] = None
    sources: List[AssessmentSubjectSource]
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    remarks: Optional[Remarks] = None


@dataclass
class SelectAssessmentSubject:
    subject_uuid: str
    type: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    remarks: Optional[Remarks] = None


@dataclass
class IdentifiesTheSubject:
    subject_uuid: str
    type: str
    title: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    remarks: Optional[Remarks] = None


@dataclass
class UsesComponent:
    component_uuid: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    responsible_parties: Optional[List[ResponsibleParty]] = None
    remarks: Optional[Remarks] = None


@dataclass
class AssessmentPlatform:
    uuid: str
    title: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    uses_components: Optional[List[UsesComponent]] = None
    remarks: Optional[Remarks] = None


@dataclass
class ObjectiveStatus:
    type: FindingTargetType
    target_id: str
    title: Optional[str] = None
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    status: ObjectiveStatus1
    implementation_status: Optional[ImplementationStatus] = None
    remarks: Optional[Remarks] = None


@dataclass
class RelevantEvidence:
    href: Optional[str] = None
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    remarks: Optional[Remarks] = None


@dataclass
class OriginatingActor:
    type: ActorType
    actor_uuid: str
    role_id: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None


@dataclass
class MitigatingFactor:
    uuid: str
    implementation_uuid: Optional[str] = None
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    subjects: Optional[List[IdentifiesTheSubject]] = None


@dataclass
class Facet:
    name: str
    system: str
    value: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    remarks: Optional[Remarks] = None


@dataclass
class RequiredAsset:
    uuid: str
    subjects: Optional[List[IdentifiesTheSubject]] = None
    title: Optional[str] = None
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    remarks: Optional[Remarks] = None


@dataclass
class AssessmentPart:
    uuid: Optional[str] = None
    name: str
    ns: Optional[str] = None
    class_: Optional[str] = None
    title: Optional[str] = None
    props: Optional[List[Property]] = None
    prose: Optional[str] = None
    parts: Optional[List[AssessmentPart]] = None
    links: Optional[List[Link]] = None


@dataclass
class Part:
    id: Optional[str] = None
    name: str
    ns: Optional[str] = None
    class_: Optional[str] = None
    title: Optional[str] = None
    props: Optional[List[Property]] = None
    prose: Optional[str] = None
    parts: Optional[List[Part]] = None
    links: Optional[List[Link]] = None


@dataclass
class Parameter:
    id: str
    class_: Optional[str] = None
    depends_on: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    label: Optional[str] = None
    usage: Optional[str] = None
    constraints: Optional[List[Constraint]] = None
    guidelines: Optional[List[Guideline]] = None
    values: Optional[List[ParameterValue]] = None
    select: Optional[Selection] = None
    remarks: Optional[Remarks] = None


@dataclass
class ServiceProtocolInformation:
    uuid: Optional[str] = None
    name: str
    title: Optional[str] = None
    port_ranges: Optional[List[PortRange]] = None


@dataclass
class Privilege:
    title: str
    description: Optional[str] = None
    functions_performed: List[FunctionsPerformed]


@dataclass
class ImplementedComponent:
    component_uuid: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    responsible_parties: Optional[List[ResponsibleParty]] = None
    remarks: Optional[Remarks] = None


@dataclass
class InventoryItem:
    uuid: str
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    responsible_parties: Optional[List[ResponsibleParty]] = None
    implemented_components: Optional[List[ImplementedComponent]] = None
    remarks: Optional[Remarks] = None


@dataclass
class AssessmentPlanTermsAndConditions:
    parts: Optional[List[AssessmentPart]] = None


@dataclass
class RevisionHistoryEntry:
    title: Optional[str] = None
    published: Optional[PublicationTimestamp] = None
    last_modified: Optional[LastModifiedTimestamp] = None
    version: DocumentVersion
    oscal_version: Optional[OSCALVersion] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    remarks: Optional[Remarks] = None


@dataclass
class Location:
    uuid: str
    title: Optional[str] = None
    address: Address
    email_addresses: Optional[List[EmailAddress]] = None
    telephone_numbers: Optional[List[TelephoneNumber]] = None
    urls: Optional[List[LocationURL]] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    remarks: Optional[Remarks] = None


@dataclass
class PartyOrganizationOrPerson:
    uuid: str
    type: PartyType
    name: Optional[str] = None
    short_name: Optional[str] = None
    external_ids: Optional[List[PartyExternalIdentifier]] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    email_addresses: Optional[List[EmailAddress]] = None
    telephone_numbers: Optional[List[TelephoneNumber]] = None
    addresses: Optional[List[Address]] = None
    location_uuids: Optional[List[LocationReference]] = None
    member_of_organizations: Optional[List[OrganizationalAffiliation]] = None
    remarks: Optional[Remarks] = None


@dataclass
class Role:
    id: str
    title: str
    short_name: Optional[str] = None
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    remarks: Optional[Remarks] = None


@dataclass
class Citation:
    text: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None


@dataclass
class Resource:
    uuid: str
    title: Optional[str] = None
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    document_ids: Optional[List[DocumentIdentifier]] = None
    citation: Optional[Citation] = None
    rlinks: Optional[List[ResourceLink]] = None
    base64: Optional[Base64] = None
    remarks: Optional[Remarks] = None


@dataclass
class BackMatter:
    resources: Optional[List[Resource]] = None


@dataclass
class AssessmentSpecificControlObjective:
    control_id: str
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    parts: List[Part]
    remarks: Optional[Remarks] = None


@dataclass
class AssessmentMethod:
    uuid: str
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    part: AssessmentPart
    remarks: Optional[Remarks] = None


@dataclass
class Step:
    uuid: str
    title: Optional[str] = None
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    reviewed_controls: Optional[ReviewedControlsAndControlObjectives] = None
    responsible_roles: Optional[List[ResponsibleRole]] = None
    remarks: Optional[Remarks] = None


@dataclass
class Activity:
    uuid: str
    title: Optional[str] = None
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    steps: Optional[List[Step]] = None
    related_controls: Optional[ReviewedControlsAndControlObjectives] = None
    responsible_roles: Optional[List[ResponsibleRole]] = None
    remarks: Optional[Remarks] = None


@dataclass
class SubjectOfAssessment:
    type: str
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    include_all: Optional[IncludeAll] = None
    include_subjects: Optional[List[SelectAssessmentSubject]] = None
    exclude_subjects: Optional[List[SelectAssessmentSubject]] = None
    remarks: Optional[Remarks] = None


@dataclass
class IdentifiedSubject:
    subject_placeholder_uuid: str
    subjects: List[SubjectOfAssessment]


@dataclass
class TaskReference:
    task_uuid: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    responsible_parties: Optional[List[ResponsibleParty]] = None
    subjects: Optional[List[SubjectOfAssessment]] = None
    identified_subject: Optional[IdentifiedSubject] = None
    remarks: Optional[Remarks] = None


@dataclass
class RiskResponseReference:
    response_uuid: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    related_tasks: Optional[List[TaskReference]] = None
    remarks: Optional[Remarks] = None


@dataclass
class RiskLogEntry:
    uuid: str
    title: Optional[str] = None
    description: Optional[str] = None
    start: str
    end: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    logged_by: Optional[List[LoggedBy]] = None
    status_change: Optional[RiskStatus] = None
    related_responses: Optional[List[RiskResponseReference]] = None
    remarks: Optional[Remarks] = None


@dataclass
class RiskLog:
    entries: List[RiskLogEntry]


@dataclass
class Component:
    uuid: str
    type: str
    title: str
    description: str
    purpose: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    status: Status
    responsible_roles: Optional[List[ResponsibleRole]] = None
    protocols: Optional[List[ServiceProtocolInformation]] = None
    remarks: Optional[Remarks] = None


@dataclass
class SystemUser:
    uuid: str
    title: Optional[str] = None
    short_name: Optional[str] = None
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    role_ids: Optional[List[RoleIdentifierReference]] = None
    authorized_privileges: Optional[List[Privilege]] = None
    remarks: Optional[Remarks] = None


@dataclass
class LocalDefinitions:
    components: Optional[List[Component]] = None
    inventory_items: Optional[List[InventoryItem]] = None
    users: Optional[List[SystemUser]] = None
    objectives_and_methods: Optional[List[AssessmentSpecificControlObjective]] = None
    activities: Optional[List[Activity]] = None
    remarks: Optional[Remarks] = None


@dataclass
class PublicationMetadata:
    title: str
    published: Optional[PublicationTimestamp] = None
    last_modified: LastModifiedTimestamp
    version: DocumentVersion
    oscal_version: OSCALVersion
    revisions: Optional[List[RevisionHistoryEntry]] = None
    document_ids: Optional[List[DocumentIdentifier]] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    roles: Optional[List[Role]] = None
    locations: Optional[List[Location]] = None
    parties: Optional[List[PartyOrganizationOrPerson]] = None
    responsible_parties: Optional[List[ResponsibleParty]] = None
    remarks: Optional[Remarks] = None


@dataclass
class AssociatedActivity:
    activity_uuid: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    responsible_roles: Optional[List[ResponsibleRole]] = None
    subjects: List[SubjectOfAssessment]
    remarks: Optional[Remarks] = None


@dataclass
class Task:
    uuid: str
    type: str
    title: str
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    timing: Optional[EventTiming] = None
    dependencies: Optional[List[TaskDependency]] = None
    tasks: Optional[List[Task]] = None
    associated_activities: Optional[List[AssociatedActivity]] = None
    subjects: Optional[List[SubjectOfAssessment]] = None
    responsible_roles: Optional[List[ResponsibleRole]] = None
    remarks: Optional[Remarks] = None


@dataclass
class AssessmentAssets:
    components: Optional[List[Component]] = None
    assessment_platforms: List[AssessmentPlatform]


@dataclass
class Origin:
    actors: List[OriginatingActor]
    related_tasks: Optional[List[TaskReference]] = None


@dataclass
class Characterization:
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    origin: Origin
    facets: List[Facet]


@dataclass
class RiskResponse:
    uuid: str
    lifecycle: str
    title: str
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    origins: Optional[List[Origin]] = None
    required_assets: Optional[List[RequiredAsset]] = None
    tasks: Optional[List[Task]] = None
    remarks: Optional[Remarks] = None


@dataclass
class SecurityAssessmentPlanSAP:
    uuid: str
    metadata: PublicationMetadata
    import_ssp: ImportSystemSecurityPlan
    local_definitions: Optional[LocalDefinitions] = None
    terms_and_conditions: Optional[AssessmentPlanTermsAndConditions] = None
    reviewed_controls: ReviewedControlsAndControlObjectives
    assessment_subjects: Optional[List[SubjectOfAssessment]] = None
    assessment_assets: Optional[AssessmentAssets] = None
    tasks: Optional[List[Task]] = None
    back_matter: Optional[BackMatter] = None


@dataclass
class Observation:
    uuid: str
    title: Optional[str] = None
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    methods: List[ObservationMethod]
    types: Optional[List[ObservationType]] = None
    origins: Optional[List[Origin]] = None
    subjects: Optional[List[IdentifiesTheSubject]] = None
    relevant_evidence: Optional[List[RelevantEvidence]] = None
    collected: str
    expires: Optional[str] = None
    remarks: Optional[Remarks] = None


@dataclass
class IdentifiedRisk:
    uuid: str
    title: str
    description: str
    statement: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    status: RiskStatus
    origins: Optional[List[Origin]] = None
    threat_ids: Optional[List[ThreatID]] = None
    characterizations: Optional[List[Characterization]] = None
    mitigating_factors: Optional[List[MitigatingFactor]] = None
    deadline: Optional[str] = None
    remediations: Optional[List[RiskResponse]] = None
    risk_log: Optional[RiskLog] = None
    related_observations: Optional[List[RelatedObservation]] = None


@dataclass
class Model:
    assessment_plan: SecurityAssessmentPlanSAP
