# generated by datamodel-codegen:
#   filename:  oscal_catalog_schema.json
#   timestamp: 2023-03-20T21:15:54+00:00

from __future__ import annotations

from dataclasses import dataclass
from enum import Enum
from typing import List, Optional


@dataclass
class Guideline:
    prose: str


ParameterValue = str


class ParameterCardinality(Enum):
    one = 'one'
    one_or_more = 'one-or-more'


@dataclass
class Selection:
    how_many: Optional[ParameterCardinality] = None
    choice: Optional[List[str]] = None


@dataclass
class IncludeAll:
    pass


LocationURL = str


LocationReference = str


class PartyType(Enum):
    person = 'person'
    organization = 'organization'


@dataclass
class PartyExternalIdentifier:
    scheme: str
    id: str


OrganizationalAffiliation = str


PartyReference = str


RoleIdentifierReference = str


@dataclass
class Base64:
    filename: Optional[str] = None
    media_type: Optional[str] = None
    value: str


@dataclass
class Link:
    href: str
    rel: Optional[str] = None
    media_type: Optional[str] = None
    text: Optional[str] = None


@dataclass
class Hash:
    algorithm: str
    value: str


Remarks = str


PublicationTimestamp = str


LastModifiedTimestamp = str


DocumentVersion = str


OSCALVersion = str


EmailAddress = str


@dataclass
class TelephoneNumber:
    type: Optional[str] = None
    number: str


AddressLine = str


@dataclass
class DocumentIdentifier:
    scheme: Optional[str] = None
    identifier: str


@dataclass
class ConstraintTest:
    expression: str
    remarks: Optional[Remarks] = None


@dataclass
class Constraint:
    description: Optional[str] = None
    tests: Optional[List[ConstraintTest]] = None


@dataclass
class ResourceLink:
    href: str
    media_type: Optional[str] = None
    hashes: Optional[List[Hash]] = None


@dataclass
class Property:
    name: str
    uuid: Optional[str] = None
    ns: Optional[str] = None
    value: str
    class_: Optional[str] = None
    remarks: Optional[Remarks] = None


@dataclass
class ResponsibleParty:
    role_id: str
    party_uuids: List[PartyReference]
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    remarks: Optional[Remarks] = None


@dataclass
class ResponsibleRole:
    role_id: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    party_uuids: Optional[List[PartyReference]] = None
    remarks: Optional[Remarks] = None


@dataclass
class Address:
    type: Optional[str] = None
    addr_lines: Optional[List[AddressLine]] = None
    city: Optional[str] = None
    state: Optional[str] = None
    postal_code: Optional[str] = None
    country: Optional[str] = None


@dataclass
class Part:
    id: Optional[str] = None
    name: str
    ns: Optional[str] = None
    class_: Optional[str] = None
    title: Optional[str] = None
    props: Optional[List[Property]] = None
    prose: Optional[str] = None
    parts: Optional[List[Part]] = None
    links: Optional[List[Link]] = None


@dataclass
class Parameter:
    id: str
    class_: Optional[str] = None
    depends_on: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    label: Optional[str] = None
    usage: Optional[str] = None
    constraints: Optional[List[Constraint]] = None
    guidelines: Optional[List[Guideline]] = None
    values: Optional[List[ParameterValue]] = None
    select: Optional[Selection] = None
    remarks: Optional[Remarks] = None


@dataclass
class RevisionHistoryEntry:
    title: Optional[str] = None
    published: Optional[PublicationTimestamp] = None
    last_modified: Optional[LastModifiedTimestamp] = None
    version: DocumentVersion
    oscal_version: Optional[OSCALVersion] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    remarks: Optional[Remarks] = None


@dataclass
class Location:
    uuid: str
    title: Optional[str] = None
    address: Address
    email_addresses: Optional[List[EmailAddress]] = None
    telephone_numbers: Optional[List[TelephoneNumber]] = None
    urls: Optional[List[LocationURL]] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    remarks: Optional[Remarks] = None


@dataclass
class PartyOrganizationOrPerson:
    uuid: str
    type: PartyType
    name: Optional[str] = None
    short_name: Optional[str] = None
    external_ids: Optional[List[PartyExternalIdentifier]] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    email_addresses: Optional[List[EmailAddress]] = None
    telephone_numbers: Optional[List[TelephoneNumber]] = None
    addresses: Optional[List[Address]] = None
    location_uuids: Optional[List[LocationReference]] = None
    member_of_organizations: Optional[List[OrganizationalAffiliation]] = None
    remarks: Optional[Remarks] = None


@dataclass
class Role:
    id: str
    title: str
    short_name: Optional[str] = None
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    remarks: Optional[Remarks] = None


@dataclass
class Citation:
    text: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None


@dataclass
class Resource:
    uuid: str
    title: Optional[str] = None
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    document_ids: Optional[List[DocumentIdentifier]] = None
    citation: Optional[Citation] = None
    rlinks: Optional[List[ResourceLink]] = None
    base64: Optional[Base64] = None
    remarks: Optional[Remarks] = None


@dataclass
class BackMatter:
    resources: Optional[List[Resource]] = None


@dataclass
class Control:
    id: str
    class_: Optional[str] = None
    title: str
    params: Optional[List[Parameter]] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    parts: Optional[List[Part]] = None
    controls: Optional[List[Control]] = None


@dataclass
class PublicationMetadata:
    title: str
    published: Optional[PublicationTimestamp] = None
    last_modified: LastModifiedTimestamp
    version: DocumentVersion
    oscal_version: OSCALVersion
    revisions: Optional[List[RevisionHistoryEntry]] = None
    document_ids: Optional[List[DocumentIdentifier]] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    roles: Optional[List[Role]] = None
    locations: Optional[List[Location]] = None
    parties: Optional[List[PartyOrganizationOrPerson]] = None
    responsible_parties: Optional[List[ResponsibleParty]] = None
    remarks: Optional[Remarks] = None


@dataclass
class ControlGroup:
    id: Optional[str] = None
    class_: Optional[str] = None
    title: str
    params: Optional[List[Parameter]] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    parts: Optional[List[Part]] = None
    groups: Optional[List[ControlGroup]] = None
    controls: Optional[List[Control]] = None


@dataclass
class Catalog:
    uuid: str
    metadata: PublicationMetadata
    params: Optional[List[Parameter]] = None
    controls: Optional[List[Control]] = None
    groups: Optional[List[ControlGroup]] = None
    back_matter: Optional[BackMatter] = None


@dataclass
class Model:
    catalog: Catalog
