# generated by datamodel-codegen:
#   filename:  oscal_complete_schema.json
#   timestamp: 2023-03-20T21:15:55+00:00

from __future__ import annotations

from dataclasses import dataclass
from enum import Enum
from typing import Any, Dict, List, Optional, Union


@dataclass
class Guideline:
    prose: str


ParameterValue = str


class ParameterCardinality(Enum):
    one = 'one'
    one_or_more = 'one-or-more'


@dataclass
class Selection:
    how_many: Optional[ParameterCardinality] = None
    choice: Optional[List[str]] = None


@dataclass
class IncludeAll:
    pass


LocationURL = str


LocationReference = str


class PartyType(Enum):
    person = 'person'
    organization = 'organization'


@dataclass
class PartyExternalIdentifier:
    scheme: str
    id: str


OrganizationalAffiliation = str


PartyReference = str


RoleIdentifierReference = str


@dataclass
class Base64:
    filename: Optional[str] = None
    media_type: Optional[str] = None
    value: str


@dataclass
class Link:
    href: str
    rel: Optional[str] = None
    media_type: Optional[str] = None
    text: Optional[str] = None


@dataclass
class Hash:
    algorithm: str
    value: str


Remarks = str


PublicationTimestamp = str


LastModifiedTimestamp = str


DocumentVersion = str


OSCALVersion = str


EmailAddress = str


@dataclass
class TelephoneNumber:
    type: Optional[str] = None
    number: str


AddressLine = str


@dataclass
class DocumentIdentifier:
    scheme: Optional[str] = None
    identifier: str


class CombinationMethod(Enum):
    use_first = 'use-first'
    merge = 'merge'
    keep = 'keep'


@dataclass
class CombinationRule:
    method: Optional[CombinationMethod] = None


class Order(Enum):
    keep = 'keep'
    ascending = 'ascending'
    descending = 'descending'


class IncludeContainedControlsWithControl(Enum):
    yes = 'yes'
    no = 'no'


MatchControlsByIdentifier = str


@dataclass
class MatchControlsByPattern:
    pattern: Optional[str] = None


@dataclass
class Call:
    with_child_controls: Optional[IncludeContainedControlsWithControl] = None
    with_ids: Optional[List[MatchControlsByIdentifier]] = None
    matching: Optional[List[MatchControlsByPattern]] = None


@dataclass
class Removal:
    by_name: Optional[str] = None
    by_class: Optional[str] = None
    by_id: Optional[str] = None
    by_item_name: Optional[str] = None
    by_ns: Optional[str] = None


class Position(Enum):
    before = 'before'
    after = 'after'
    starting = 'starting'
    ending = 'ending'


@dataclass
class ImportComponentDefinition:
    href: str


@dataclass
class IncorporatesComponent:
    component_uuid: str
    description: str


class State(Enum):
    under_development = 'under-development'
    operational = 'operational'
    disposition = 'disposition'
    other = 'other'


@dataclass
class Status:
    state: State
    remarks: Optional[Remarks] = None


class Transport(Enum):
    TCP = 'TCP'
    UDP = 'UDP'


@dataclass
class PortRange:
    start: Optional[int] = None
    end: Optional[int] = None
    transport: Optional[Transport] = None


@dataclass
class ImplementationStatus:
    state: str
    remarks: Optional[Remarks] = None


FunctionsPerformed = str


@dataclass
class SetParameterValue:
    param_id: str
    values: List[ParameterValue]
    remarks: Optional[Remarks] = None


@dataclass
class SystemIdentification:
    identifier_type: Optional[str] = None
    id: str


@dataclass
class ImportProfile:
    href: str
    remarks: Optional[Remarks] = None


InformationTypeSystematizedIdentifier = str


@dataclass
class InformationTypeCategorization:
    system: str
    information_type_ids: Optional[List[InformationTypeSystematizedIdentifier]] = None


BaseLevelConfidentialityIntegrityOrAvailability = str


SelectedLevelConfidentialityIntegrityOrAvailability = str


AdjustmentJustification = str


@dataclass
class SecurityImpactLevel:
    security_objective_confidentiality: str
    security_objective_integrity: str
    security_objective_availability: str


class State1(Enum):
    operational = 'operational'
    under_development = 'under-development'
    under_major_modification = 'under-major-modification'
    disposition = 'disposition'
    other = 'other'


@dataclass
class Status1:
    state: State1
    remarks: Optional[Remarks] = None


SystemAuthorizationDate = str


@dataclass
class ImportSystemSecurityPlan:
    href: str
    remarks: Optional[Remarks] = None


@dataclass
class OnDateCondition:
    date: str


@dataclass
class OnDateRangeCondition:
    start: str
    end: str


class TimeUnit(Enum):
    seconds = 'seconds'
    minutes = 'minutes'
    hours = 'hours'
    days = 'days'
    months = 'months'
    years = 'years'


@dataclass
class FrequencyCondition:
    period: int
    unit: TimeUnit


@dataclass
class EventTiming:
    on_date: Optional[OnDateCondition] = None
    within_date_range: Optional[OnDateRangeCondition] = None
    at_frequency: Optional[FrequencyCondition] = None


@dataclass
class TaskDependency:
    task_uuid: str
    remarks: Optional[Remarks] = None


IncludeSpecificStatements = str


@dataclass
class SelectControl:
    control_id: str
    statement_ids: Optional[List[IncludeSpecificStatements]] = None


@dataclass
class SelectObjective:
    objective_id: str


@dataclass
class AssessmentSubjectSource:
    task_uuid: str


class FindingTargetType(Enum):
    statement_id = 'statement-id'
    objective_id = 'objective-id'


class ObjectiveStatusState(Enum):
    satisfied = 'satisfied'
    not_satisfied = 'not-satisfied'


@dataclass
class ObjectiveStatus1:
    state: ObjectiveStatusState
    reason: Optional[str] = None
    remarks: Optional[Remarks] = None


ObservationMethod = str


ObservationType = str


class ActorType(Enum):
    tool = 'tool'
    assessment_platform = 'assessment-platform'
    party = 'party'


@dataclass
class ThreatID:
    system: str
    href: Optional[str] = None
    id: str


@dataclass
class RelatedObservation:
    observation_uuid: str


@dataclass
class LoggedBy:
    party_uuid: str
    role_id: Optional[str] = None


RiskStatus = str


@dataclass
class AssociatedRisk:
    risk_uuid: str


@dataclass
class ImportAssessmentPlan:
    href: str
    remarks: Optional[Remarks] = None


@dataclass
class ConstraintTest:
    expression: str
    remarks: Optional[Remarks] = None


@dataclass
class Constraint:
    description: Optional[str] = None
    tests: Optional[List[ConstraintTest]] = None


@dataclass
class ResourceLink:
    href: str
    media_type: Optional[str] = None
    hashes: Optional[List[Hash]] = None


@dataclass
class Property:
    name: str
    uuid: Optional[str] = None
    ns: Optional[str] = None
    value: str
    class_: Optional[str] = None
    remarks: Optional[Remarks] = None


@dataclass
class ResponsibleParty:
    role_id: str
    party_uuids: List[PartyReference]
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    remarks: Optional[Remarks] = None


@dataclass
class ResponsibleRole:
    role_id: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    party_uuids: Optional[List[PartyReference]] = None
    remarks: Optional[Remarks] = None


@dataclass
class Address:
    type: Optional[str] = None
    addr_lines: Optional[List[AddressLine]] = None
    city: Optional[str] = None
    state: Optional[str] = None
    postal_code: Optional[str] = None
    country: Optional[str] = None


@dataclass
class ImportResource:
    href: str
    include_all: Optional[IncludeAll] = None
    include_controls: Optional[List[Call]] = None
    exclude_controls: Optional[List[Call]] = None


@dataclass
class ParameterSetting:
    param_id: str
    class_: Optional[str] = None
    depends_on: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    label: Optional[str] = None
    usage: Optional[str] = None
    constraints: Optional[List[Constraint]] = None
    guidelines: Optional[List[Guideline]] = None
    values: Optional[List[ParameterValue]] = None
    select: Optional[Selection] = None


@dataclass
class SelectControls:
    order: Optional[Order] = None
    include_all: Optional[IncludeAll] = None
    include_controls: Optional[List[Call]] = None
    exclude_controls: Optional[List[Call]] = None


@dataclass
class ControlStatementImplementation:
    statement_id: str
    uuid: str
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    responsible_roles: Optional[List[ResponsibleRole]] = None
    remarks: Optional[Remarks] = None


@dataclass
class ServiceProtocolInformation:
    uuid: Optional[str] = None
    name: str
    title: Optional[str] = None
    port_ranges: Optional[List[PortRange]] = None


@dataclass
class Privilege:
    title: str
    description: Optional[str] = None
    functions_performed: List[FunctionsPerformed]


@dataclass
class ImplementedComponent:
    component_uuid: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    responsible_parties: Optional[List[ResponsibleParty]] = None
    remarks: Optional[Remarks] = None


@dataclass
class InventoryItem:
    uuid: str
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    responsible_parties: Optional[List[ResponsibleParty]] = None
    implemented_components: Optional[List[ImplementedComponent]] = None
    remarks: Optional[Remarks] = None


@dataclass
class ConfidentialityImpactLevel:
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    base: BaseLevelConfidentialityIntegrityOrAvailability
    selected: Optional[SelectedLevelConfidentialityIntegrityOrAvailability] = None
    adjustment_justification: Optional[AdjustmentJustification] = None


@dataclass
class IntegrityImpactLevel:
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    base: BaseLevelConfidentialityIntegrityOrAvailability
    selected: Optional[SelectedLevelConfidentialityIntegrityOrAvailability] = None
    adjustment_justification: Optional[AdjustmentJustification] = None


@dataclass
class AvailabilityImpactLevel:
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    base: BaseLevelConfidentialityIntegrityOrAvailability
    selected: Optional[SelectedLevelConfidentialityIntegrityOrAvailability] = None
    adjustment_justification: Optional[AdjustmentJustification] = None


@dataclass
class InformationType:
    uuid: Optional[str] = None
    title: str
    description: str
    categorizations: Optional[List[InformationTypeCategorization]] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    confidentiality_impact: ConfidentialityImpactLevel
    integrity_impact: IntegrityImpactLevel
    availability_impact: AvailabilityImpactLevel


@dataclass
class SystemInformation:
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    information_types: List[InformationType]


@dataclass
class Diagram:
    uuid: str
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    caption: Optional[str] = None
    remarks: Optional[Remarks] = None


@dataclass
class NetworkArchitecture:
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    diagrams: Optional[List[Diagram]] = None
    remarks: Optional[Remarks] = None


@dataclass
class DataFlow:
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    diagrams: Optional[List[Diagram]] = None
    remarks: Optional[Remarks] = None


@dataclass
class LeveragedAuthorization:
    uuid: str
    title: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    party_uuid: str
    date_authorized: SystemAuthorizationDate
    remarks: Optional[Remarks] = None


@dataclass
class ProvidedControlImplementation:
    uuid: str
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    responsible_roles: Optional[List[ResponsibleRole]] = None
    remarks: Optional[Remarks] = None


@dataclass
class ControlImplementationResponsibility:
    uuid: str
    provided_uuid: Optional[str] = None
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    responsible_roles: Optional[List[ResponsibleRole]] = None
    remarks: Optional[Remarks] = None


@dataclass
class Export:
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    provided: Optional[List[ProvidedControlImplementation]] = None
    responsibilities: Optional[List[ControlImplementationResponsibility]] = None
    remarks: Optional[Remarks] = None


@dataclass
class InheritedControlImplementation:
    uuid: str
    provided_uuid: Optional[str] = None
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    responsible_roles: Optional[List[ResponsibleRole]] = None


@dataclass
class SatisfiedControlImplementationResponsibility:
    uuid: str
    responsibility_uuid: Optional[str] = None
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    responsible_roles: Optional[List[ResponsibleRole]] = None
    remarks: Optional[Remarks] = None


@dataclass
class ComponentControlImplementation:
    component_uuid: str
    uuid: str
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    set_parameters: Optional[List[SetParameterValue]] = None
    implementation_status: Optional[ImplementationStatus] = None
    export: Optional[Export] = None
    inherited: Optional[List[InheritedControlImplementation]] = None
    satisfied: Optional[List[SatisfiedControlImplementationResponsibility]] = None
    responsible_roles: Optional[List[ResponsibleRole]] = None
    remarks: Optional[Remarks] = None


@dataclass
class AssessedControls:
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    include_all: Optional[IncludeAll] = None
    include_controls: Optional[List[SelectControl]] = None
    exclude_controls: Optional[List[SelectControl]] = None
    remarks: Optional[Remarks] = None


@dataclass
class ReferencedControlObjectives:
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    include_all: Optional[IncludeAll] = None
    include_objectives: Optional[List[SelectObjective]] = None
    exclude_objectives: Optional[List[SelectObjective]] = None
    remarks: Optional[Remarks] = None


@dataclass
class ReviewedControlsAndControlObjectives:
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    control_selections: List[AssessedControls]
    control_objective_selections: Optional[List[ReferencedControlObjectives]] = None
    remarks: Optional[Remarks] = None


@dataclass
class AssessmentSubjectPlaceholder:
    uuid: str
    description: Optional[str] = None
    sources: List[AssessmentSubjectSource]
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    remarks: Optional[Remarks] = None


@dataclass
class SelectAssessmentSubject:
    subject_uuid: str
    type: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    remarks: Optional[Remarks] = None


@dataclass
class IdentifiesTheSubject:
    subject_uuid: str
    type: str
    title: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    remarks: Optional[Remarks] = None


@dataclass
class UsesComponent:
    component_uuid: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    responsible_parties: Optional[List[ResponsibleParty]] = None
    remarks: Optional[Remarks] = None


@dataclass
class AssessmentPlatform:
    uuid: str
    title: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    uses_components: Optional[List[UsesComponent]] = None
    remarks: Optional[Remarks] = None


@dataclass
class ObjectiveStatus:
    type: FindingTargetType
    target_id: str
    title: Optional[str] = None
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    status: ObjectiveStatus1
    implementation_status: Optional[ImplementationStatus] = None
    remarks: Optional[Remarks] = None


@dataclass
class RelevantEvidence:
    href: Optional[str] = None
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    remarks: Optional[Remarks] = None


@dataclass
class OriginatingActor:
    type: ActorType
    actor_uuid: str
    role_id: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None


@dataclass
class MitigatingFactor:
    uuid: str
    implementation_uuid: Optional[str] = None
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    subjects: Optional[List[IdentifiesTheSubject]] = None


@dataclass
class Facet:
    name: str
    system: str
    value: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    remarks: Optional[Remarks] = None


@dataclass
class RequiredAsset:
    uuid: str
    subjects: Optional[List[IdentifiesTheSubject]] = None
    title: Optional[str] = None
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    remarks: Optional[Remarks] = None


@dataclass
class AssessmentPart:
    uuid: Optional[str] = None
    name: str
    ns: Optional[str] = None
    class_: Optional[str] = None
    title: Optional[str] = None
    props: Optional[List[Property]] = None
    prose: Optional[str] = None
    parts: Optional[List[AssessmentPart]] = None
    links: Optional[List[Link]] = None


@dataclass
class AttestationStatements:
    responsible_parties: Optional[List[ResponsibleParty]] = None
    parts: List[AssessmentPart]


@dataclass
class Origin1:
    actors: List[OriginatingActor]


@dataclass
class POAMItem:
    uuid: Optional[str] = None
    title: str
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    origins: Optional[List[Origin1]] = None
    related_observations: Optional[List[RelatedObservation]] = None
    related_risks: Optional[List[AssociatedRisk]] = None
    remarks: Optional[Remarks] = None


@dataclass
class Part:
    id: Optional[str] = None
    name: str
    ns: Optional[str] = None
    class_: Optional[str] = None
    title: Optional[str] = None
    props: Optional[List[Property]] = None
    prose: Optional[str] = None
    parts: Optional[List[Part]] = None
    links: Optional[List[Link]] = None


@dataclass
class Parameter:
    id: str
    class_: Optional[str] = None
    depends_on: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    label: Optional[str] = None
    usage: Optional[str] = None
    constraints: Optional[List[Constraint]] = None
    guidelines: Optional[List[Guideline]] = None
    values: Optional[List[ParameterValue]] = None
    select: Optional[Selection] = None
    remarks: Optional[Remarks] = None


@dataclass
class RevisionHistoryEntry:
    title: Optional[str] = None
    published: Optional[PublicationTimestamp] = None
    last_modified: Optional[LastModifiedTimestamp] = None
    version: DocumentVersion
    oscal_version: Optional[OSCALVersion] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    remarks: Optional[Remarks] = None


@dataclass
class Location:
    uuid: str
    title: Optional[str] = None
    address: Address
    email_addresses: Optional[List[EmailAddress]] = None
    telephone_numbers: Optional[List[TelephoneNumber]] = None
    urls: Optional[List[LocationURL]] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    remarks: Optional[Remarks] = None


@dataclass
class PartyOrganizationOrPerson:
    uuid: str
    type: PartyType
    name: Optional[str] = None
    short_name: Optional[str] = None
    external_ids: Optional[List[PartyExternalIdentifier]] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    email_addresses: Optional[List[EmailAddress]] = None
    telephone_numbers: Optional[List[TelephoneNumber]] = None
    addresses: Optional[List[Address]] = None
    location_uuids: Optional[List[LocationReference]] = None
    member_of_organizations: Optional[List[OrganizationalAffiliation]] = None
    remarks: Optional[Remarks] = None


@dataclass
class Role:
    id: str
    title: str
    short_name: Optional[str] = None
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    remarks: Optional[Remarks] = None


@dataclass
class Citation:
    text: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None


@dataclass
class Resource:
    uuid: str
    title: Optional[str] = None
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    document_ids: Optional[List[DocumentIdentifier]] = None
    citation: Optional[Citation] = None
    rlinks: Optional[List[ResourceLink]] = None
    base64: Optional[Base64] = None
    remarks: Optional[Remarks] = None


@dataclass
class BackMatter:
    resources: Optional[List[Resource]] = None


@dataclass
class ControlGroup1:
    id: Optional[str] = None
    class_: Optional[str] = None
    title: str
    params: Optional[List[Parameter]] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    parts: Optional[List[Part]] = None
    groups: Optional[List[ControlGroup1]] = None
    insert_controls: Optional[List[SelectControls]] = None


@dataclass
class Addition:
    position: Optional[Position] = None
    by_id: Optional[str] = None
    title: Optional[str] = None
    params: Optional[List[Parameter]] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    parts: Optional[List[Part]] = None


@dataclass
class ControlImplementation:
    uuid: str
    control_id: str
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    set_parameters: Optional[List[SetParameterValue]] = None
    responsible_roles: Optional[List[ResponsibleRole]] = None
    statements: Optional[List[ControlStatementImplementation]] = None
    remarks: Optional[Remarks] = None


@dataclass
class Component1:
    uuid: str
    type: str
    title: str
    description: str
    purpose: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    status: Status
    responsible_roles: Optional[List[ResponsibleRole]] = None
    protocols: Optional[List[ServiceProtocolInformation]] = None
    remarks: Optional[Remarks] = None


@dataclass
class SystemUser:
    uuid: str
    title: Optional[str] = None
    short_name: Optional[str] = None
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    role_ids: Optional[List[RoleIdentifierReference]] = None
    authorized_privileges: Optional[List[Privilege]] = None
    remarks: Optional[Remarks] = None


@dataclass
class AuthorizationBoundary:
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    diagrams: Optional[List[Diagram]] = None
    remarks: Optional[Remarks] = None


@dataclass
class SystemImplementation:
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    leveraged_authorizations: Optional[List[LeveragedAuthorization]] = None
    users: List[SystemUser]
    components: List[Component1]
    inventory_items: Optional[List[InventoryItem]] = None
    remarks: Optional[Remarks] = None


@dataclass
class SpecificControlStatement:
    statement_id: str
    uuid: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    responsible_roles: Optional[List[ResponsibleRole]] = None
    by_components: Optional[List[ComponentControlImplementation]] = None
    remarks: Optional[Remarks] = None


@dataclass
class AssessmentPlanTermsAndConditions:
    parts: Optional[List[AssessmentPart]] = None


@dataclass
class AssessmentSpecificControlObjective:
    control_id: str
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    parts: List[Part]
    remarks: Optional[Remarks] = None


@dataclass
class AssessmentMethod:
    uuid: str
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    part: AssessmentPart
    remarks: Optional[Remarks] = None


@dataclass
class Step:
    uuid: str
    title: Optional[str] = None
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    reviewed_controls: Optional[ReviewedControlsAndControlObjectives] = None
    responsible_roles: Optional[List[ResponsibleRole]] = None
    remarks: Optional[Remarks] = None


@dataclass
class Activity:
    uuid: str
    title: Optional[str] = None
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    steps: Optional[List[Step]] = None
    related_controls: Optional[ReviewedControlsAndControlObjectives] = None
    responsible_roles: Optional[List[ResponsibleRole]] = None
    remarks: Optional[Remarks] = None


@dataclass
class SubjectOfAssessment:
    type: str
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    include_all: Optional[IncludeAll] = None
    include_subjects: Optional[List[SelectAssessmentSubject]] = None
    exclude_subjects: Optional[List[SelectAssessmentSubject]] = None
    remarks: Optional[Remarks] = None


@dataclass
class AssessmentAssets:
    components: Optional[List[Component1]] = None
    assessment_platforms: List[AssessmentPlatform]


@dataclass
class IdentifiedSubject:
    subject_placeholder_uuid: str
    subjects: List[SubjectOfAssessment]


@dataclass
class TaskReference:
    task_uuid: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    responsible_parties: Optional[List[ResponsibleParty]] = None
    subjects: Optional[List[SubjectOfAssessment]] = None
    identified_subject: Optional[IdentifiedSubject] = None
    remarks: Optional[Remarks] = None


@dataclass
class RiskResponseReference:
    response_uuid: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    related_tasks: Optional[List[TaskReference]] = None
    remarks: Optional[Remarks] = None


@dataclass
class RiskLogEntry:
    uuid: str
    title: Optional[str] = None
    description: Optional[str] = None
    start: str
    end: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    logged_by: Optional[List[LoggedBy]] = None
    status_change: Optional[RiskStatus] = None
    related_responses: Optional[List[RiskResponseReference]] = None
    remarks: Optional[Remarks] = None


@dataclass
class RiskLog:
    entries: List[RiskLogEntry]


@dataclass
class LocalDefinitions1:
    objectives_and_methods: Optional[List[AssessmentSpecificControlObjective]] = None
    activities: Optional[List[Activity]] = None
    remarks: Optional[Remarks] = None


@dataclass
class AssessmentLogEntry:
    uuid: str
    title: Optional[str] = None
    description: Optional[str] = None
    start: str
    end: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    logged_by: Optional[List[LoggedBy]] = None
    related_tasks: Optional[List[TaskReference]] = None
    remarks: Optional[Remarks] = None


@dataclass
class AssessmentLog:
    entries: List[AssessmentLogEntry]


@dataclass
class LocalDefinitions3:
    components: Optional[List[Component1]] = None
    inventory_items: Optional[List[InventoryItem]] = None
    remarks: Optional[Remarks] = None


@dataclass
class Control:
    id: str
    class_: Optional[str] = None
    title: str
    params: Optional[List[Parameter]] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    parts: Optional[List[Part]] = None
    controls: Optional[List[Control]] = None


@dataclass
class PublicationMetadata:
    title: str
    published: Optional[PublicationTimestamp] = None
    last_modified: LastModifiedTimestamp
    version: DocumentVersion
    oscal_version: OSCALVersion
    revisions: Optional[List[RevisionHistoryEntry]] = None
    document_ids: Optional[List[DocumentIdentifier]] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    roles: Optional[List[Role]] = None
    locations: Optional[List[Location]] = None
    parties: Optional[List[PartyOrganizationOrPerson]] = None
    responsible_parties: Optional[List[ResponsibleParty]] = None
    remarks: Optional[Remarks] = None


@dataclass
class CustomGrouping:
    groups: Optional[List[ControlGroup1]] = None
    insert_controls: Optional[List[SelectControls]] = None


@dataclass
class MergeControls:
    combine: Optional[CombinationRule] = None
    flat: Optional[Dict[str, Any]] = None
    as_is: Optional[bool] = None
    custom: Optional[CustomGrouping] = None


@dataclass
class Alteration:
    control_id: str
    removes: Optional[List[Removal]] = None
    adds: Optional[List[Addition]] = None


@dataclass
class ControlImplementationSet:
    uuid: str
    source: str
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    set_parameters: Optional[List[SetParameterValue]] = None
    implemented_requirements: List[ControlImplementation]


@dataclass
class SystemCharacteristics:
    system_ids: List[SystemIdentification]
    system_name: str
    system_name_short: Optional[str] = None
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    date_authorized: Optional[SystemAuthorizationDate] = None
    security_sensitivity_level: str
    system_information: SystemInformation
    security_impact_level: SecurityImpactLevel
    status: Status1
    authorization_boundary: AuthorizationBoundary
    network_architecture: Optional[NetworkArchitecture] = None
    data_flow: Optional[DataFlow] = None
    responsible_parties: Optional[List[ResponsibleParty]] = None
    remarks: Optional[Remarks] = None


@dataclass
class ControlBasedRequirement:
    uuid: str
    control_id: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    set_parameters: Optional[List[SetParameterValue]] = None
    responsible_roles: Optional[List[ResponsibleRole]] = None
    statements: Optional[List[SpecificControlStatement]] = None
    by_components: Optional[List[ComponentControlImplementation]] = None
    remarks: Optional[Remarks] = None


@dataclass
class LocalDefinitions:
    components: Optional[List[Component1]] = None
    inventory_items: Optional[List[InventoryItem]] = None
    users: Optional[List[SystemUser]] = None
    objectives_and_methods: Optional[List[AssessmentSpecificControlObjective]] = None
    activities: Optional[List[Activity]] = None
    remarks: Optional[Remarks] = None


@dataclass
class AssociatedActivity:
    activity_uuid: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    responsible_roles: Optional[List[ResponsibleRole]] = None
    subjects: List[SubjectOfAssessment]
    remarks: Optional[Remarks] = None


@dataclass
class Task:
    uuid: str
    type: str
    title: str
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    timing: Optional[EventTiming] = None
    dependencies: Optional[List[TaskDependency]] = None
    tasks: Optional[List[Task]] = None
    associated_activities: Optional[List[AssociatedActivity]] = None
    subjects: Optional[List[SubjectOfAssessment]] = None
    responsible_roles: Optional[List[ResponsibleRole]] = None
    remarks: Optional[Remarks] = None


@dataclass
class Origin:
    actors: List[OriginatingActor]
    related_tasks: Optional[List[TaskReference]] = None


@dataclass
class Characterization:
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    origin: Origin
    facets: List[Facet]


@dataclass
class RiskResponse:
    uuid: str
    lifecycle: str
    title: str
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    origins: Optional[List[Origin]] = None
    required_assets: Optional[List[RequiredAsset]] = None
    tasks: Optional[List[Task]] = None
    remarks: Optional[Remarks] = None


@dataclass
class LocalDefinitions2:
    components: Optional[List[Component1]] = None
    inventory_items: Optional[List[InventoryItem]] = None
    users: Optional[List[SystemUser]] = None
    assessment_assets: Optional[AssessmentAssets] = None
    tasks: Optional[List[Task]] = None


@dataclass
class Finding:
    uuid: str
    title: str
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    origins: Optional[List[Origin]] = None
    target: ObjectiveStatus
    implementation_statement_uuid: Optional[str] = None
    related_observations: Optional[List[RelatedObservation]] = None
    related_risks: Optional[List[AssociatedRisk]] = None
    remarks: Optional[Remarks] = None


@dataclass
class ControlGroup:
    id: Optional[str] = None
    class_: Optional[str] = None
    title: str
    params: Optional[List[Parameter]] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    parts: Optional[List[Part]] = None
    groups: Optional[List[ControlGroup]] = None
    controls: Optional[List[Control]] = None


@dataclass
class ModifyControls:
    set_parameters: Optional[List[ParameterSetting]] = None
    alters: Optional[List[Alteration]] = None


@dataclass
class Component:
    uuid: str
    type: str
    title: str
    description: str
    purpose: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    responsible_roles: Optional[List[ResponsibleRole]] = None
    protocols: Optional[List[ServiceProtocolInformation]] = None
    control_implementations: Optional[List[ControlImplementationSet]] = None
    remarks: Optional[Remarks] = None


@dataclass
class Capability:
    uuid: str
    name: str
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    incorporates_components: Optional[List[IncorporatesComponent]] = None
    control_implementations: Optional[List[ControlImplementationSet]] = None
    remarks: Optional[Remarks] = None


@dataclass
class ControlImplementation1:
    description: str
    set_parameters: Optional[List[SetParameterValue]] = None
    implemented_requirements: List[ControlBasedRequirement]


@dataclass
class SecurityAssessmentPlanSAP:
    uuid: str
    metadata: PublicationMetadata
    import_ssp: ImportSystemSecurityPlan
    local_definitions: Optional[LocalDefinitions] = None
    terms_and_conditions: Optional[AssessmentPlanTermsAndConditions] = None
    reviewed_controls: ReviewedControlsAndControlObjectives
    assessment_subjects: Optional[List[SubjectOfAssessment]] = None
    assessment_assets: Optional[AssessmentAssets] = None
    tasks: Optional[List[Task]] = None
    back_matter: Optional[BackMatter] = None


@dataclass
class Observation:
    uuid: str
    title: Optional[str] = None
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    methods: List[ObservationMethod]
    types: Optional[List[ObservationType]] = None
    origins: Optional[List[Origin]] = None
    subjects: Optional[List[IdentifiesTheSubject]] = None
    relevant_evidence: Optional[List[RelevantEvidence]] = None
    collected: str
    expires: Optional[str] = None
    remarks: Optional[Remarks] = None


@dataclass
class IdentifiedRisk:
    uuid: str
    title: str
    description: str
    statement: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    status: RiskStatus
    origins: Optional[List[Origin]] = None
    threat_ids: Optional[List[ThreatID]] = None
    characterizations: Optional[List[Characterization]] = None
    mitigating_factors: Optional[List[MitigatingFactor]] = None
    deadline: Optional[str] = None
    remediations: Optional[List[RiskResponse]] = None
    risk_log: Optional[RiskLog] = None
    related_observations: Optional[List[RelatedObservation]] = None


@dataclass
class AssessmentResult:
    uuid: str
    title: str
    description: str
    start: str
    end: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    local_definitions: Optional[LocalDefinitions2] = None
    reviewed_controls: ReviewedControlsAndControlObjectives
    attestations: Optional[List[AttestationStatements]] = None
    assessment_log: Optional[AssessmentLog] = None
    observations: Optional[List[Observation]] = None
    risks: Optional[List[IdentifiedRisk]] = None
    findings: Optional[List[Finding]] = None
    remarks: Optional[Remarks] = None


@dataclass
class PlanOfActionAndMilestonesPOAM:
    uuid: str
    metadata: PublicationMetadata
    import_ssp: Optional[ImportSystemSecurityPlan] = None
    system_id: Optional[SystemIdentification] = None
    local_definitions: Optional[LocalDefinitions3] = None
    observations: Optional[List[Observation]] = None
    risks: Optional[List[IdentifiedRisk]] = None
    poam_items: List[POAMItem]
    back_matter: Optional[BackMatter] = None


@dataclass
class ModelItem4:
    assessment_plan: SecurityAssessmentPlanSAP


@dataclass
class ModelItem6:
    plan_of_action_and_milestones: PlanOfActionAndMilestonesPOAM


@dataclass
class Catalog:
    uuid: str
    metadata: PublicationMetadata
    params: Optional[List[Parameter]] = None
    controls: Optional[List[Control]] = None
    groups: Optional[List[ControlGroup]] = None
    back_matter: Optional[BackMatter] = None


@dataclass
class Profile:
    uuid: str
    metadata: PublicationMetadata
    imports: List[ImportResource]
    merge: Optional[MergeControls] = None
    modify: Optional[ModifyControls] = None
    back_matter: Optional[BackMatter] = None


@dataclass
class ComponentDefinition:
    uuid: str
    metadata: PublicationMetadata
    import_component_definitions: Optional[List[ImportComponentDefinition]] = None
    components: Optional[List[Component]] = None
    capabilities: Optional[List[Capability]] = None
    back_matter: Optional[BackMatter] = None


@dataclass
class SystemSecurityPlanSSP:
    uuid: str
    metadata: PublicationMetadata
    import_profile: ImportProfile
    system_characteristics: SystemCharacteristics
    system_implementation: SystemImplementation
    control_implementation: ControlImplementation1
    back_matter: Optional[BackMatter] = None


@dataclass
class SecurityAssessmentResultsSAR:
    uuid: str
    metadata: PublicationMetadata
    import_ap: ImportAssessmentPlan
    local_definitions: Optional[LocalDefinitions1] = None
    results: List[AssessmentResult]
    back_matter: Optional[BackMatter] = None


@dataclass
class ModelItem:
    catalog: Catalog


@dataclass
class ModelItem1:
    profile: Profile


@dataclass
class ModelItem2:
    component_definition: ComponentDefinition


@dataclass
class ModelItem3:
    system_security_plan: SystemSecurityPlanSSP


@dataclass
class ModelItem5:
    assessment_results: SecurityAssessmentResultsSAR


Model = Union[
    ModelItem, ModelItem1, ModelItem2, ModelItem3, ModelItem4, ModelItem5, ModelItem6
]
