# generated by datamodel-codegen:
#   filename:  oscal_component_schema.json
#   timestamp: 2023-03-20T21:15:55+00:00

from __future__ import annotations

from dataclasses import dataclass
from enum import Enum
from typing import List, Optional


@dataclass
class ImportComponentDefinition:
    href: str


@dataclass
class IncorporatesComponent:
    component_uuid: str
    description: str


class State(Enum):
    under_development = 'under-development'
    operational = 'operational'
    disposition = 'disposition'
    other = 'other'


class Transport(Enum):
    TCP = 'TCP'
    UDP = 'UDP'


@dataclass
class PortRange:
    start: Optional[int] = None
    end: Optional[int] = None
    transport: Optional[Transport] = None


FunctionsPerformed = str


ParameterValue = str


@dataclass
class SystemIdentification:
    identifier_type: Optional[str] = None
    id: str


LocationURL = str


LocationReference = str


class PartyType(Enum):
    person = 'person'
    organization = 'organization'


@dataclass
class PartyExternalIdentifier:
    scheme: str
    id: str


OrganizationalAffiliation = str


PartyReference = str


RoleIdentifierReference = str


@dataclass
class Base64:
    filename: Optional[str] = None
    media_type: Optional[str] = None
    value: str


@dataclass
class Link:
    href: str
    rel: Optional[str] = None
    media_type: Optional[str] = None
    text: Optional[str] = None


@dataclass
class Hash:
    algorithm: str
    value: str


Remarks = str


PublicationTimestamp = str


LastModifiedTimestamp = str


DocumentVersion = str


OSCALVersion = str


EmailAddress = str


@dataclass
class TelephoneNumber:
    type: Optional[str] = None
    number: str


AddressLine = str


@dataclass
class DocumentIdentifier:
    scheme: Optional[str] = None
    identifier: str


@dataclass
class ConstraintTest:
    expression: str
    remarks: Optional[Remarks] = None


@dataclass
class Constraint:
    description: Optional[str] = None
    tests: Optional[List[ConstraintTest]] = None


@dataclass
class Guideline:
    prose: str


class ParameterCardinality(Enum):
    one = 'one'
    one_or_more = 'one-or-more'


@dataclass
class Selection:
    how_many: Optional[ParameterCardinality] = None
    choice: Optional[List[str]] = None


@dataclass
class IncludeAll:
    pass


@dataclass
class Status:
    state: State
    remarks: Optional[Remarks] = None


@dataclass
class ServiceProtocolInformation:
    uuid: Optional[str] = None
    name: str
    title: Optional[str] = None
    port_ranges: Optional[List[PortRange]] = None


@dataclass
class ImplementationStatus:
    state: str
    remarks: Optional[Remarks] = None


@dataclass
class Privilege:
    title: str
    description: Optional[str] = None
    functions_performed: List[FunctionsPerformed]


@dataclass
class SetParameterValue:
    param_id: str
    values: List[ParameterValue]
    remarks: Optional[Remarks] = None


@dataclass
class ResourceLink:
    href: str
    media_type: Optional[str] = None
    hashes: Optional[List[Hash]] = None


@dataclass
class Property:
    name: str
    uuid: Optional[str] = None
    ns: Optional[str] = None
    value: str
    class_: Optional[str] = None
    remarks: Optional[Remarks] = None


@dataclass
class ResponsibleParty:
    role_id: str
    party_uuids: List[PartyReference]
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    remarks: Optional[Remarks] = None


@dataclass
class ResponsibleRole:
    role_id: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    party_uuids: Optional[List[PartyReference]] = None
    remarks: Optional[Remarks] = None


@dataclass
class Address:
    type: Optional[str] = None
    addr_lines: Optional[List[AddressLine]] = None
    city: Optional[str] = None
    state: Optional[str] = None
    postal_code: Optional[str] = None
    country: Optional[str] = None


@dataclass
class Part:
    id: Optional[str] = None
    name: str
    ns: Optional[str] = None
    class_: Optional[str] = None
    title: Optional[str] = None
    props: Optional[List[Property]] = None
    prose: Optional[str] = None
    parts: Optional[List[Part]] = None
    links: Optional[List[Link]] = None


@dataclass
class Parameter:
    id: str
    class_: Optional[str] = None
    depends_on: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    label: Optional[str] = None
    usage: Optional[str] = None
    constraints: Optional[List[Constraint]] = None
    guidelines: Optional[List[Guideline]] = None
    values: Optional[List[ParameterValue]] = None
    select: Optional[Selection] = None
    remarks: Optional[Remarks] = None


@dataclass
class ControlStatementImplementation:
    statement_id: str
    uuid: str
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    responsible_roles: Optional[List[ResponsibleRole]] = None
    remarks: Optional[Remarks] = None


@dataclass
class Component1:
    uuid: str
    type: str
    title: str
    description: str
    purpose: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    status: Status
    responsible_roles: Optional[List[ResponsibleRole]] = None
    protocols: Optional[List[ServiceProtocolInformation]] = None
    remarks: Optional[Remarks] = None


@dataclass
class SystemUser:
    uuid: str
    title: Optional[str] = None
    short_name: Optional[str] = None
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    role_ids: Optional[List[RoleIdentifierReference]] = None
    authorized_privileges: Optional[List[Privilege]] = None
    remarks: Optional[Remarks] = None


@dataclass
class ImplementedComponent:
    component_uuid: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    responsible_parties: Optional[List[ResponsibleParty]] = None
    remarks: Optional[Remarks] = None


@dataclass
class InventoryItem:
    uuid: str
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    responsible_parties: Optional[List[ResponsibleParty]] = None
    implemented_components: Optional[List[ImplementedComponent]] = None
    remarks: Optional[Remarks] = None


@dataclass
class RevisionHistoryEntry:
    title: Optional[str] = None
    published: Optional[PublicationTimestamp] = None
    last_modified: Optional[LastModifiedTimestamp] = None
    version: DocumentVersion
    oscal_version: Optional[OSCALVersion] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    remarks: Optional[Remarks] = None


@dataclass
class Location:
    uuid: str
    title: Optional[str] = None
    address: Address
    email_addresses: Optional[List[EmailAddress]] = None
    telephone_numbers: Optional[List[TelephoneNumber]] = None
    urls: Optional[List[LocationURL]] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    remarks: Optional[Remarks] = None


@dataclass
class PartyOrganizationOrPerson:
    uuid: str
    type: PartyType
    name: Optional[str] = None
    short_name: Optional[str] = None
    external_ids: Optional[List[PartyExternalIdentifier]] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    email_addresses: Optional[List[EmailAddress]] = None
    telephone_numbers: Optional[List[TelephoneNumber]] = None
    addresses: Optional[List[Address]] = None
    location_uuids: Optional[List[LocationReference]] = None
    member_of_organizations: Optional[List[OrganizationalAffiliation]] = None
    remarks: Optional[Remarks] = None


@dataclass
class Role:
    id: str
    title: str
    short_name: Optional[str] = None
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    remarks: Optional[Remarks] = None


@dataclass
class Citation:
    text: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None


@dataclass
class Resource:
    uuid: str
    title: Optional[str] = None
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    document_ids: Optional[List[DocumentIdentifier]] = None
    citation: Optional[Citation] = None
    rlinks: Optional[List[ResourceLink]] = None
    base64: Optional[Base64] = None
    remarks: Optional[Remarks] = None


@dataclass
class BackMatter:
    resources: Optional[List[Resource]] = None


@dataclass
class ControlImplementation:
    uuid: str
    control_id: str
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    set_parameters: Optional[List[SetParameterValue]] = None
    responsible_roles: Optional[List[ResponsibleRole]] = None
    statements: Optional[List[ControlStatementImplementation]] = None
    remarks: Optional[Remarks] = None


@dataclass
class PublicationMetadata:
    title: str
    published: Optional[PublicationTimestamp] = None
    last_modified: LastModifiedTimestamp
    version: DocumentVersion
    oscal_version: OSCALVersion
    revisions: Optional[List[RevisionHistoryEntry]] = None
    document_ids: Optional[List[DocumentIdentifier]] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    roles: Optional[List[Role]] = None
    locations: Optional[List[Location]] = None
    parties: Optional[List[PartyOrganizationOrPerson]] = None
    responsible_parties: Optional[List[ResponsibleParty]] = None
    remarks: Optional[Remarks] = None


@dataclass
class ControlImplementationSet:
    uuid: str
    source: str
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    set_parameters: Optional[List[SetParameterValue]] = None
    implemented_requirements: List[ControlImplementation]


@dataclass
class Component:
    uuid: str
    type: str
    title: str
    description: str
    purpose: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    responsible_roles: Optional[List[ResponsibleRole]] = None
    protocols: Optional[List[ServiceProtocolInformation]] = None
    control_implementations: Optional[List[ControlImplementationSet]] = None
    remarks: Optional[Remarks] = None


@dataclass
class Capability:
    uuid: str
    name: str
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    incorporates_components: Optional[List[IncorporatesComponent]] = None
    control_implementations: Optional[List[ControlImplementationSet]] = None
    remarks: Optional[Remarks] = None


@dataclass
class ComponentDefinition:
    uuid: str
    metadata: PublicationMetadata
    import_component_definitions: Optional[List[ImportComponentDefinition]] = None
    components: Optional[List[Component]] = None
    capabilities: Optional[List[Capability]] = None
    back_matter: Optional[BackMatter] = None


@dataclass
class Model:
    component_definition: ComponentDefinition
