# generated by datamodel-codegen:
#   filename:  oscal_ssp_schema.json
#   timestamp: 2023-03-20T21:15:56+00:00

from __future__ import annotations

from dataclasses import dataclass
from enum import Enum
from typing import List, Optional

InformationTypeSystematizedIdentifier = str


@dataclass
class InformationTypeCategorization:
    system: str
    information_type_ids: Optional[List[InformationTypeSystematizedIdentifier]] = None


BaseLevelConfidentialityIntegrityOrAvailability = str


SelectedLevelConfidentialityIntegrityOrAvailability = str


AdjustmentJustification = str


@dataclass
class SecurityImpactLevel:
    security_objective_confidentiality: str
    security_objective_integrity: str
    security_objective_availability: str


class State(Enum):
    operational = 'operational'
    under_development = 'under-development'
    under_major_modification = 'under-major-modification'
    disposition = 'disposition'
    other = 'other'


SystemAuthorizationDate = str


LocationURL = str


LocationReference = str


class PartyType(Enum):
    person = 'person'
    organization = 'organization'


@dataclass
class PartyExternalIdentifier:
    scheme: str
    id: str


OrganizationalAffiliation = str


PartyReference = str


RoleIdentifierReference = str


@dataclass
class Base64:
    filename: Optional[str] = None
    media_type: Optional[str] = None
    value: str


@dataclass
class Link:
    href: str
    rel: Optional[str] = None
    media_type: Optional[str] = None
    text: Optional[str] = None


@dataclass
class Hash:
    algorithm: str
    value: str


Remarks = str


PublicationTimestamp = str


LastModifiedTimestamp = str


DocumentVersion = str


OSCALVersion = str


EmailAddress = str


@dataclass
class TelephoneNumber:
    type: Optional[str] = None
    number: str


AddressLine = str


@dataclass
class DocumentIdentifier:
    scheme: Optional[str] = None
    identifier: str


class State1(Enum):
    under_development = 'under-development'
    operational = 'operational'
    disposition = 'disposition'
    other = 'other'


@dataclass
class Status1:
    state: State1
    remarks: Optional[Remarks] = None


class Transport(Enum):
    TCP = 'TCP'
    UDP = 'UDP'


@dataclass
class PortRange:
    start: Optional[int] = None
    end: Optional[int] = None
    transport: Optional[Transport] = None


@dataclass
class ImplementationStatus:
    state: str
    remarks: Optional[Remarks] = None


FunctionsPerformed = str


ParameterValue = str


@dataclass
class SetParameterValue:
    param_id: str
    values: List[ParameterValue]
    remarks: Optional[Remarks] = None


@dataclass
class SystemIdentification:
    identifier_type: Optional[str] = None
    id: str


@dataclass
class ConstraintTest:
    expression: str
    remarks: Optional[Remarks] = None


@dataclass
class Constraint:
    description: Optional[str] = None
    tests: Optional[List[ConstraintTest]] = None


@dataclass
class Guideline:
    prose: str


class ParameterCardinality(Enum):
    one = 'one'
    one_or_more = 'one-or-more'


@dataclass
class Selection:
    how_many: Optional[ParameterCardinality] = None
    choice: Optional[List[str]] = None


@dataclass
class IncludeAll:
    pass


@dataclass
class ImportProfile:
    href: str
    remarks: Optional[Remarks] = None


@dataclass
class Status:
    state: State
    remarks: Optional[Remarks] = None


@dataclass
class ResourceLink:
    href: str
    media_type: Optional[str] = None
    hashes: Optional[List[Hash]] = None


@dataclass
class Property:
    name: str
    uuid: Optional[str] = None
    ns: Optional[str] = None
    value: str
    class_: Optional[str] = None
    remarks: Optional[Remarks] = None


@dataclass
class ResponsibleParty:
    role_id: str
    party_uuids: List[PartyReference]
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    remarks: Optional[Remarks] = None


@dataclass
class ResponsibleRole:
    role_id: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    party_uuids: Optional[List[PartyReference]] = None
    remarks: Optional[Remarks] = None


@dataclass
class Address:
    type: Optional[str] = None
    addr_lines: Optional[List[AddressLine]] = None
    city: Optional[str] = None
    state: Optional[str] = None
    postal_code: Optional[str] = None
    country: Optional[str] = None


@dataclass
class ServiceProtocolInformation:
    uuid: Optional[str] = None
    name: str
    title: Optional[str] = None
    port_ranges: Optional[List[PortRange]] = None


@dataclass
class Privilege:
    title: str
    description: Optional[str] = None
    functions_performed: List[FunctionsPerformed]


@dataclass
class ImplementedComponent:
    component_uuid: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    responsible_parties: Optional[List[ResponsibleParty]] = None
    remarks: Optional[Remarks] = None


@dataclass
class InventoryItem:
    uuid: str
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    responsible_parties: Optional[List[ResponsibleParty]] = None
    implemented_components: Optional[List[ImplementedComponent]] = None
    remarks: Optional[Remarks] = None


@dataclass
class Part:
    id: Optional[str] = None
    name: str
    ns: Optional[str] = None
    class_: Optional[str] = None
    title: Optional[str] = None
    props: Optional[List[Property]] = None
    prose: Optional[str] = None
    parts: Optional[List[Part]] = None
    links: Optional[List[Link]] = None


@dataclass
class Parameter:
    id: str
    class_: Optional[str] = None
    depends_on: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    label: Optional[str] = None
    usage: Optional[str] = None
    constraints: Optional[List[Constraint]] = None
    guidelines: Optional[List[Guideline]] = None
    values: Optional[List[ParameterValue]] = None
    select: Optional[Selection] = None
    remarks: Optional[Remarks] = None


@dataclass
class ConfidentialityImpactLevel:
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    base: BaseLevelConfidentialityIntegrityOrAvailability
    selected: Optional[SelectedLevelConfidentialityIntegrityOrAvailability] = None
    adjustment_justification: Optional[AdjustmentJustification] = None


@dataclass
class IntegrityImpactLevel:
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    base: BaseLevelConfidentialityIntegrityOrAvailability
    selected: Optional[SelectedLevelConfidentialityIntegrityOrAvailability] = None
    adjustment_justification: Optional[AdjustmentJustification] = None


@dataclass
class AvailabilityImpactLevel:
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    base: BaseLevelConfidentialityIntegrityOrAvailability
    selected: Optional[SelectedLevelConfidentialityIntegrityOrAvailability] = None
    adjustment_justification: Optional[AdjustmentJustification] = None


@dataclass
class InformationType:
    uuid: Optional[str] = None
    title: str
    description: str
    categorizations: Optional[List[InformationTypeCategorization]] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    confidentiality_impact: ConfidentialityImpactLevel
    integrity_impact: IntegrityImpactLevel
    availability_impact: AvailabilityImpactLevel


@dataclass
class SystemInformation:
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    information_types: List[InformationType]


@dataclass
class Diagram:
    uuid: str
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    caption: Optional[str] = None
    remarks: Optional[Remarks] = None


@dataclass
class NetworkArchitecture:
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    diagrams: Optional[List[Diagram]] = None
    remarks: Optional[Remarks] = None


@dataclass
class DataFlow:
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    diagrams: Optional[List[Diagram]] = None
    remarks: Optional[Remarks] = None


@dataclass
class LeveragedAuthorization:
    uuid: str
    title: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    party_uuid: str
    date_authorized: SystemAuthorizationDate
    remarks: Optional[Remarks] = None


@dataclass
class ProvidedControlImplementation:
    uuid: str
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    responsible_roles: Optional[List[ResponsibleRole]] = None
    remarks: Optional[Remarks] = None


@dataclass
class ControlImplementationResponsibility:
    uuid: str
    provided_uuid: Optional[str] = None
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    responsible_roles: Optional[List[ResponsibleRole]] = None
    remarks: Optional[Remarks] = None


@dataclass
class Export:
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    provided: Optional[List[ProvidedControlImplementation]] = None
    responsibilities: Optional[List[ControlImplementationResponsibility]] = None
    remarks: Optional[Remarks] = None


@dataclass
class InheritedControlImplementation:
    uuid: str
    provided_uuid: Optional[str] = None
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    responsible_roles: Optional[List[ResponsibleRole]] = None


@dataclass
class SatisfiedControlImplementationResponsibility:
    uuid: str
    responsibility_uuid: Optional[str] = None
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    responsible_roles: Optional[List[ResponsibleRole]] = None
    remarks: Optional[Remarks] = None


@dataclass
class ComponentControlImplementation:
    component_uuid: str
    uuid: str
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    set_parameters: Optional[List[SetParameterValue]] = None
    implementation_status: Optional[ImplementationStatus] = None
    export: Optional[Export] = None
    inherited: Optional[List[InheritedControlImplementation]] = None
    satisfied: Optional[List[SatisfiedControlImplementationResponsibility]] = None
    responsible_roles: Optional[List[ResponsibleRole]] = None
    remarks: Optional[Remarks] = None


@dataclass
class RevisionHistoryEntry:
    title: Optional[str] = None
    published: Optional[PublicationTimestamp] = None
    last_modified: Optional[LastModifiedTimestamp] = None
    version: DocumentVersion
    oscal_version: Optional[OSCALVersion] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    remarks: Optional[Remarks] = None


@dataclass
class Location:
    uuid: str
    title: Optional[str] = None
    address: Address
    email_addresses: Optional[List[EmailAddress]] = None
    telephone_numbers: Optional[List[TelephoneNumber]] = None
    urls: Optional[List[LocationURL]] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    remarks: Optional[Remarks] = None


@dataclass
class PartyOrganizationOrPerson:
    uuid: str
    type: PartyType
    name: Optional[str] = None
    short_name: Optional[str] = None
    external_ids: Optional[List[PartyExternalIdentifier]] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    email_addresses: Optional[List[EmailAddress]] = None
    telephone_numbers: Optional[List[TelephoneNumber]] = None
    addresses: Optional[List[Address]] = None
    location_uuids: Optional[List[LocationReference]] = None
    member_of_organizations: Optional[List[OrganizationalAffiliation]] = None
    remarks: Optional[Remarks] = None


@dataclass
class Role:
    id: str
    title: str
    short_name: Optional[str] = None
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    remarks: Optional[Remarks] = None


@dataclass
class Citation:
    text: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None


@dataclass
class Resource:
    uuid: str
    title: Optional[str] = None
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    document_ids: Optional[List[DocumentIdentifier]] = None
    citation: Optional[Citation] = None
    rlinks: Optional[List[ResourceLink]] = None
    base64: Optional[Base64] = None
    remarks: Optional[Remarks] = None


@dataclass
class BackMatter:
    resources: Optional[List[Resource]] = None


@dataclass
class Component:
    uuid: str
    type: str
    title: str
    description: str
    purpose: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    status: Status1
    responsible_roles: Optional[List[ResponsibleRole]] = None
    protocols: Optional[List[ServiceProtocolInformation]] = None
    remarks: Optional[Remarks] = None


@dataclass
class SystemUser:
    uuid: str
    title: Optional[str] = None
    short_name: Optional[str] = None
    description: Optional[str] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    role_ids: Optional[List[RoleIdentifierReference]] = None
    authorized_privileges: Optional[List[Privilege]] = None
    remarks: Optional[Remarks] = None


@dataclass
class AuthorizationBoundary:
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    diagrams: Optional[List[Diagram]] = None
    remarks: Optional[Remarks] = None


@dataclass
class SystemImplementation:
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    leveraged_authorizations: Optional[List[LeveragedAuthorization]] = None
    users: List[SystemUser]
    components: List[Component]
    inventory_items: Optional[List[InventoryItem]] = None
    remarks: Optional[Remarks] = None


@dataclass
class SpecificControlStatement:
    statement_id: str
    uuid: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    responsible_roles: Optional[List[ResponsibleRole]] = None
    by_components: Optional[List[ComponentControlImplementation]] = None
    remarks: Optional[Remarks] = None


@dataclass
class PublicationMetadata:
    title: str
    published: Optional[PublicationTimestamp] = None
    last_modified: LastModifiedTimestamp
    version: DocumentVersion
    oscal_version: OSCALVersion
    revisions: Optional[List[RevisionHistoryEntry]] = None
    document_ids: Optional[List[DocumentIdentifier]] = None
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    roles: Optional[List[Role]] = None
    locations: Optional[List[Location]] = None
    parties: Optional[List[PartyOrganizationOrPerson]] = None
    responsible_parties: Optional[List[ResponsibleParty]] = None
    remarks: Optional[Remarks] = None


@dataclass
class SystemCharacteristics:
    system_ids: List[SystemIdentification]
    system_name: str
    system_name_short: Optional[str] = None
    description: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    date_authorized: Optional[SystemAuthorizationDate] = None
    security_sensitivity_level: str
    system_information: SystemInformation
    security_impact_level: SecurityImpactLevel
    status: Status
    authorization_boundary: AuthorizationBoundary
    network_architecture: Optional[NetworkArchitecture] = None
    data_flow: Optional[DataFlow] = None
    responsible_parties: Optional[List[ResponsibleParty]] = None
    remarks: Optional[Remarks] = None


@dataclass
class ControlBasedRequirement:
    uuid: str
    control_id: str
    props: Optional[List[Property]] = None
    links: Optional[List[Link]] = None
    set_parameters: Optional[List[SetParameterValue]] = None
    responsible_roles: Optional[List[ResponsibleRole]] = None
    statements: Optional[List[SpecificControlStatement]] = None
    by_components: Optional[List[ComponentControlImplementation]] = None
    remarks: Optional[Remarks] = None


@dataclass
class ControlImplementation:
    description: str
    set_parameters: Optional[List[SetParameterValue]] = None
    implemented_requirements: List[ControlBasedRequirement]


@dataclass
class SystemSecurityPlanSSP:
    uuid: str
    metadata: PublicationMetadata
    import_profile: ImportProfile
    system_characteristics: SystemCharacteristics
    system_implementation: SystemImplementation
    control_implementation: ControlImplementation
    back_matter: Optional[BackMatter] = None


@dataclass
class Model:
    system_security_plan: SystemSecurityPlanSSP
